
#include <iostream>
#include <fstream>
#include <cstdlib>
#include <stdlib.h>
#include <errno.h>
#include <math.h>

#define PI 3.141592653589793

int main( int argc, char **argv )
{
   if ( argc > 1 )
   {
      size_t len = strlen( argv[ 1 ] );
      if ( len > 4 && strcmp( ".psd", argv[ 1 ] + len - 4 ) == 0 || strcmp( ".png", argv[ 1 ] + len - 4 ) == 0 )
      {
         for ( int degrees = 0; degrees < 360; degrees += 1 )
         {
            char name[ 1024 ];
            strcpy_s( name, argv[ 1 ] );
            name[ len - 4 ] = '\0';

            char icoName[ 1024 ];
            sprintf_s( icoName, "%s%d.ico", name, degrees );

            double const radians = double( degrees ) * PI / 180.0;
            char const xHotspot = char( 16.0 + 13.0 * cos( radians ) );
            char const yHotspot = char( 16.0 - 13.0 * sin( radians ) );

            char command[ 1024 ];
            sprintf_s( command, "IM\\convert.exe \"%s\" -background none -flatten -distort SRT \"29,16 1,1 %d %d,%d\" \"%s\"", argv[ 1 ], -degrees, xHotspot, yHotspot, icoName );
            std::system( command );

            std::ifstream icoFile( icoName, std::ios::binary | std::ios::ate );
            if ( icoFile )
            {
               char curName[ 1024 ];
               sprintf_s( curName, "%s%d.cur", name, degrees );

               std::ofstream curFile( curName, std::ios::binary );
               if ( curFile )
               {
                  unsigned const icoSize = unsigned( icoFile.tellg() );

                  icoFile.seekg( icoFile.beg );
                  char * buffer = new char[ icoSize ];
                  icoFile.read( buffer, icoSize );
                  icoFile.close();
                  buffer[ 2 ] = 2; // 1 for .ICO, 2 for .CUR
                  buffer[ 10 ] = xHotspot; // xHotspot
                  buffer[ 11 ] = 0;
                  buffer[ 12 ] = yHotspot; // yHotspot
                  buffer[ 13 ] = 0;
                  curFile.write( buffer, icoSize );
                  delete[] buffer;
               }
            }
            sprintf_s( command, "del \"%s\"", icoName );
            std::system( command );
         }
      }
      else if ( len > 4 && strcmp( ".ico", argv[ 1 ] + len - 4 ) == 0 )
      {
         std::ifstream icoFile( argv[ 1 ], std::ios::binary | std::ios::ate );
         if ( icoFile )
         {
            char newName[ 1024 ];
            strcpy_s( newName, argv[ 1 ] );
            strcpy_s( newName + len - 3, 4, "cur" );

            std::ofstream curFile( newName, std::ios::binary );
            if ( curFile )
            {
               unsigned const icoSize = unsigned( icoFile.tellg() );

               char const xHotspot = 16;
               char const yHotspot = 16;

               icoFile.seekg( icoFile.beg );
               char * buffer = new char[ icoSize ];
               icoFile.read( buffer, icoSize );
               icoFile.close();
               buffer[ 2 ] = 2; // 1 for .ICO, 2 for .CUR
               buffer[ 10 ] = xHotspot; // xHotspot
               buffer[ 11 ] = 0;
               buffer[ 12 ] = yHotspot; // yHotspot
               buffer[ 13 ] = 0;
               curFile.write( buffer, icoSize );
               delete[] buffer;
            }
         }
      }
   }

   return 0;
}